using Edu.Common.Enum;
using Edu.Model.Entity.Web;
using Edu.Model.ViewModel.Web;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using VT.FW.DB.Dapper;

namespace Edu.Repository.Web
{
    public class RB_Web_NewsTypeRepository:BaseRepository<RB_Web_NewsType>
    {
        /// <summary>
        /// 获取网站新闻类型分页列表
        /// </summary>
        /// <param name="pageIndex">页码</param>
        /// <param name="pageSize">每页显示调试</param>
        /// <param name="rowsCount">总条数</param>
        /// <param name="query">查询条件</param>
        /// <returns></returns>
        public List<RB_Web_NewsType_ViewModel> GetWebNewsTypePageRepository(int pageIndex, int pageSize, out long rowsCount, RB_Web_NewsType_ViewModel query)
        {
            rowsCount = 0;
            var parameters = new DynamicParameters();
            StringBuilder builder = new StringBuilder();
            builder.Append(@"
SELECT A.* 
FROM RB_Web_NewsType AS A
WHERE 1=1
");
            if (query == null)
            {
                return new List<RB_Web_NewsType_ViewModel>();
            }
            else
            {
                if (query.Group_Id > 0)
                {
                    builder.AppendFormat(@" AND A.{0}={1} ", nameof(RB_Web_NewsType_ViewModel.Group_Id), query.Group_Id);
                }
                if (!string.IsNullOrEmpty(query.TypeName))
                {
                    builder.AppendFormat(" AND A.{0} LIKE @TypeName ", nameof(RB_Web_NewsType_ViewModel.TypeName));
                    parameters.Add("TypeName", "%" + query.TypeName.Trim() + "%");
                }
                if (query.Status >= 0)
                {
                    builder.AppendFormat(@" AND A.{0}={1} ", nameof(RB_Web_NewsType_ViewModel.Status), (int)query.Status);
                }
            }
            builder.AppendFormat(" ORDER BY A.{0} DESC ", nameof(RB_Web_NewsType_ViewModel.Id));
            return GetPage<RB_Web_NewsType_ViewModel>(pageIndex, pageSize, out rowsCount, builder.ToString(), parameters).ToList();
        }

        /// <summary>
        /// 获取网站新闻类型列表
        /// </summary>
        /// <param name="query">查询条件</param>
        /// <returns></returns>
        public List<RB_Web_NewsType_ViewModel> GetWebNewsTypeListRepository(RB_Web_NewsType_ViewModel query)
        {
            var parameters = new DynamicParameters();
            StringBuilder builder = new StringBuilder();
            builder.Append(@"
SELECT A.* 
FROM RB_Web_NewsType AS A
WHERE 1=1
");
            builder.AppendFormat(@" AND A.{0}={1} ", nameof(RB_Web_NewsType_ViewModel.Status), (int)DateStateEnum.Normal);
            if (query == null)
            {
                return new List<RB_Web_NewsType_ViewModel>();
            }
            else
            {
                if (query.Group_Id > 0)
                {
                    builder.AppendFormat(@" AND A.{0}={1} ", nameof(RB_Web_NewsType_ViewModel.Group_Id), query.Group_Id);
                }
                if (!string.IsNullOrEmpty(query.TypeName))
                {
                    builder.AppendFormat(" AND A.{0} LIKE @TypeName ", nameof(RB_Web_NewsType_ViewModel.TypeName));
                    parameters.Add("TypeName", "%" + query.TypeName.Trim() + "%");
                }
            }
            return Get<RB_Web_NewsType_ViewModel>(builder.ToString()).ToList();
        }
    }
}
